#!/usr/bin/env python
"""
_Information on DQM jobs by status_ [experimental code]

T0Mon: this class is used in the detail pages 
"""

from T0.DAS.Database.Oracle.Jobs.RepackMergeJobsByStatus import * 

class DQMJobsByStatus(RepackMergeJobsByStatus):
   sql="""SELECT
       wmbs_job.id                            AS job_id,
       wmbs_file_runlumi_map.run              AS run_id,
       wmbs_job.state_time                    AS state_time,
      COUNT(DISTINCT( wmbs_job_assoc.fileid)) AS inputfiles,
       primary_dataset.name                   AS dataset,
       CASE  
         WHEN sd.stream_id is null  THEN 'BULK'
         else 'EXPRESS'
       END as status 
    FROM
       wmbs_job
    JOIN  wmbs_jobgroup                ON  wmbs_job.jobgroup                            =  wmbs_jobgroup.id
    JOIN  wmbs_job_assoc               ON  wmbs_job.id                                  =  wmbs_job_assoc.job
    JOIN  wmbs_file_details            ON  wmbs_file_details.id                         =  wmbs_job_assoc.fileid
    JOIN  wmbs_file_runlumi_map        ON  wmbs_file_details.id                         =  wmbs_file_runlumi_map.fileid
    JOIN  wmbs_file_dataset_path_assoc ON  wmbs_file_details.id                         =  wmbs_file_dataset_path_assoc.file_id
    JOIN  dataset_path                 ON  wmbs_file_dataset_path_assoc.dataset_path_id =  dataset_path.id
    JOIN  primary_dataset              ON  primary_dataset.id                           =  dataset_path.primary_dataset
    LEFT OUTER JOIN stream_special_dataset_assoc sd ON (sd.primary_dataset_id = dataset_path.primary_dataset)
    %s
    WHERE
       dataset_path.data_tier =
      (SELECT data_tier.id  FROM data_tier
      WHERE  data_tier.name = 'DQM')
    %s
    GROUP BY
       wmbs_job.id,
       wmbs_job.state_time,
       wmbs_file_runlumi_map.run,
       primary_dataset.name,
       sd.stream_id
    ORDER BY
       wmbs_job.id DESC """
   def buildQuery(self):
      self.sql=self.sql % (self.sqlRun,self.whereCond)

class DQMJobsByStatus_count(RepackMergeJobsByStatus_count):
   sql="""SELECT
      COUNT( DISTINCT wmbs_job.id)
    FROM
       wmbs_job
    JOIN  wmbs_jobgroup                ON  wmbs_job.jobgroup                            =  wmbs_jobgroup.id
    JOIN  wmbs_job_assoc               ON  wmbs_job.id                                  =  wmbs_job_assoc.job
    JOIN  wmbs_file_details            ON  wmbs_file_details.id                         =  wmbs_job_assoc.fileid
    JOIN  wmbs_file_runlumi_map        ON  wmbs_file_details.id                         =  wmbs_file_runlumi_map.fileid
    JOIN  wmbs_file_dataset_path_assoc ON  wmbs_file_details.id                         =  wmbs_file_dataset_path_assoc.file_id
    JOIN  dataset_path                 ON  wmbs_file_dataset_path_assoc.dataset_path_id =  dataset_path.id
    JOIN  primary_dataset              ON  primary_dataset.id                           =  dataset_path.primary_dataset
    %s
    WHERE
       dataset_path.data_tier =
      (SELECT data_tier.id  FROM data_tier
      WHERE  data_tier.name = 'DQM')  %s """
   def buildQuery(self):
      self.sql=self.sql % (self.sqlRun,self.whereCond) 