#!/usr/bin/env python
"""
_Information on express jobs by status_

T0Mon: this class is used in the detail pages 
"""


from T0.DAS.Database.Oracle.Jobs.RepackMergeJobsByStatus import * 


class ExpressMergeJobsByStatus(RepackMergeJobsByStatus):

    sqlFileSet="'ExpressMergeable'"
    dataTier=""
    sql="""SELECT     \
  wmbs_job.id                             AS  job_id,   \
  wmbs_file_runlumi_map.run               AS run_id,   \
  wmbs_job.state_time                     AS state_time,   \
  COUNT(DISTINCT( wmbs_job_assoc.fileid)) AS inputfiles   \
FROM   \
  wmbs_job   \
JOIN wmbs_jobgroup         ON wmbs_job.jobgroup    = wmbs_jobgroup.id   \
JOIN wmbs_job_assoc        ON wmbs_job.id          = wmbs_job_assoc.job   \
JOIN wmbs_file_details     ON wmbs_file_details.id = wmbs_job_assoc.fileid   \
JOIN wmbs_file_runlumi_map ON wmbs_file_details.id = wmbs_file_runlumi_map.fileid %s  \
WHERE   %s \
  wmbs_jobgroup.subscription =   \
  (SELECT wmbs_subscription.id  FROM   wmbs_subscription   \
  WHERE   wmbs_subscription.fileset =   \
    (SELECT      wmbs_fileset.id    FROM   wmbs_fileset   \
     WHERE   wmbs_fileset.name =%s) ) %s
GROUP BY
  wmbs_job.id,
  wmbs_job.state_time,
  wmbs_file_runlumi_map.run
ORDER BY
  wmbs_job.id DESC """
  
class ExpressMergeJobsByStatus_count(RepackMergeJobsByStatus_count):

    sqlFileSet="'ExpressMergeable'"
    dataTier=""
    sql="""SELECT   COUNT (DISTINCT  wmbs_job.id)
FROM  
  wmbs_job  
JOIN  wmbs_job_assoc               ON  wmbs_job.id        =  wmbs_job_assoc.job
JOIN wmbs_jobgroup                 ON wmbs_job.jobgroup    = wmbs_jobgroup.id  %s
WHERE  %s
  wmbs_jobgroup.subscription =  
  (SELECT wmbs_subscription.id  FROM   wmbs_subscription  
  WHERE   wmbs_subscription.fileset =  
    (SELECT      wmbs_fileset.id    FROM   wmbs_fileset  
     WHERE   wmbs_fileset.name =%s) )
     %s"""