#!/usr/bin/env python
"""
_Information on all the active new and used express jobs (and their files)_
T0Mon: this class is used in the front page
"""


from T0.DAS.Database.Oracle.LongResultQuery import LongResultQuery 
from WMCore.Database.DBFormatter import DBFormatter

class LastNewUsedExpress(LongResultQuery):
  
   #the query select all the new or used jobs (1,2) and return all their express jobs
   #TO DO: drop the LongResultQuery.
   #       find MAX(job_id) and fetch last X rows 
   sql="""
        SELECT
  express_job_def.job_id                                   AS job_id,
  streamer.run_id                                          AS run_id,
  express_job_def.definition_time                          AS def_time,
  COUNT(DISTINCT( express_job_streamer_assoc.streamer_id)) AS num_streamers
FROM
  express_job_def
JOIN express_job_streamer_assoc ON express_job_def.job_id = express_job_streamer_assoc.job_id
JOIN streamer                   ON streamer.streamer_id   = express_job_streamer_assoc.streamer_id
WHERE
  express_job_def.job_status  = 1
OR express_job_def.job_status = 2
GROUP BY
  express_job_def.job_id,
  express_job_def.definition_time,
  streamer.run_id
ORDER BY
  express_job_def.job_id DESC
   """

     
   def execute(self, uplimit,downlimit, conn = None, transaction = False):
        bindVars = {"uplimit": uplimit,"downlimit": downlimit,}
        result = self.dbi.processData(self.sql, bindVars, conn = conn,
                                      transaction = transaction)
        
        return self.formatDict(result)
   
class LastNewUsedExpress_count(DBFormatter):
   sql="""SELECT
  count( distinct express_job_def.job_id) as count 
FROM
  express_job_def
JOIN express_job_streamer_assoc ON express_job_def.job_id = express_job_streamer_assoc.job_id
JOIN streamer                   ON streamer.streamer_id   = express_job_streamer_assoc.streamer_id
WHERE
  express_job_def.job_status  = 1
OR express_job_def.job_status = 2 """
