#!/usr/bin/env python
"""
_Information on reco  jobs by status_

T0Mon: this class is used in the detail pages 
"""

from T0.DAS.Database.Oracle.Jobs.RepackMergeJobsByStatus import * 

class RecoJobsByStatus(RepackMergeJobsByStatus):

   sqlFileSet="'Reconstructable'"

    
   sql=""" SELECT  \
       wmbs_job.id                            AS job_id,  \
       wmbs_file_runlumi_map.run              AS run_id,  \
       wmbs_job.state_time                    AS state_time,  \
      COUNT(DISTINCT( wmbs_job_assoc.fileid)) AS inputfiles,  \
       primary_dataset.name                   AS dataset  \
FROM wmbs_job   \
    JOIN  wmbs_jobgroup                ON  wmbs_job.jobgroup                            =  wmbs_jobgroup.id  \
    JOIN  wmbs_job_assoc               ON  wmbs_job.id                                  =  wmbs_job_assoc.job  \
    JOIN  wmbs_file_details            ON  wmbs_file_details.id                         =  wmbs_job_assoc.fileid  \
    JOIN  wmbs_file_runlumi_map        ON  wmbs_file_details.id                         =  wmbs_file_runlumi_map.fileid  \
    JOIN  wmbs_file_dataset_path_assoc ON  wmbs_file_details.id                         =  wmbs_file_dataset_path_assoc.file_id  \
    JOIN  dataset_path                 ON  wmbs_file_dataset_path_assoc.dataset_path_id =  dataset_path.id  \
    JOIN  primary_dataset              ON  primary_dataset.id                           =  dataset_path.primary_dataset  \
    INNER JOIN data_tier               ON  data_tier.id                                 =  dataset_path.data_tier \
    %s  WHERE   \
    wmbs_jobgroup.subscription =   ( SELECT id FROM  wmbs_fileset WHERE name = %s )  \
        %s   GROUP BY  \
   wmbs_job.id, wmbs_file_runlumi_map.run,wmbs_job.state_time,primary_dataset.name 
   ORDER BY     wmbs_job.id   DESC  """
   def buildQuery(self):
        self.sql=self.sql % (self.sqlRun,self.sqlFileSet,self.whereCond)
        
        
class RecoJobsByStatus_count(RepackMergeJobsByStatus_count):

   sqlFileSet="'Reconstructable'"

   sql=""" SELECT COUNT( DISTINCT  wmbs_job.id)
FROM wmbs_job  
    JOIN  wmbs_jobgroup                ON  wmbs_job.jobgroup                            =  wmbs_jobgroup.id 
    JOIN  wmbs_job_assoc               ON  wmbs_job.id                                  =  wmbs_job_assoc.job 
    JOIN  wmbs_file_details            ON  wmbs_file_details.id                         =  wmbs_job_assoc.fileid 
    JOIN  wmbs_file_dataset_path_assoc ON  wmbs_file_details.id                         =  wmbs_file_dataset_path_assoc.file_id 
    JOIN  dataset_path                 ON  wmbs_file_dataset_path_assoc.dataset_path_id =  dataset_path.id 
    INNER JOIN data_tier               ON  data_tier.id                                 =  dataset_path.data_tier
    %s  WHERE  
    wmbs_jobgroup.subscription =   ( SELECT id FROM  wmbs_fileset WHERE name = %s )   %s """
   def buildQuery(self):
        self.sql=self.sql % (self.sqlRun,self.sqlFileSet,self.whereCond)