#!/usr/bin/env python
"""
_Information on repack jobs by status_

T0Mon: this class is used in the detail pages 
"""

from T0.DAS.Database.Oracle.Jobs.ExpressJobsByStatus import *

class RepackJobsByStatus(ExpressJobsByStatus):

   sql="""
        SELECT
           repack_job_def.job_id                                  AS  job_id,
           streamer.run_id                                        AS run_id,
           repack_job_def.definition_time                         AS def_time,
          COUNT(DISTINCT( repack_job_streamer_assoc.streamer_id)) AS num_streamers,
           stream.name                                            AS stream,
           job_status.status                                      AS job_status
        FROM
           repack_job_def
        JOIN  job_status                ON  repack_job_def.job_status =  job_status.id
        JOIN  repack_job_streamer_assoc ON  repack_job_def.job_id     =  repack_job_streamer_assoc.job_id
        JOIN  streamer                  ON  streamer.streamer_id      =  repack_job_streamer_assoc.streamer_id
        JOIN  stream                    ON  streamer.stream_id        =  stream.id
        WHERE
           repack_job_def.job_status = (SELECT job_status.id FROM job_status WHERE job_status.status= :status)
        %s
        GROUP BY
           repack_job_def.job_id,
           repack_job_def.definition_time,
           streamer.run_id,
           stream.name,
           job_status.status
        ORDER BY
           repack_job_def.job_id DESC
     """
  
class RepackJobsByStatus_count(ExpressJobsByStatus_count):
   sql="""SELECT COUNT (DISTINCT   repack_job_def.job_id)
        FROM repack_job_def %s
        WHERE
           repack_job_def.job_status = (SELECT job_status.id FROM job_status WHERE job_status.status= :status) """
   sqlJoinRun="""        JOIN  job_status                ON  (repack_job_def.job_status =  job_status.id)
        JOIN  repack_job_streamer_assoc ON  (repack_job_def.job_id     =  repack_job_streamer_assoc.job_id)
        JOIN  streamer                  ON  (streamer.streamer_id      =  repack_job_streamer_assoc.streamer_id AND streamer.run_id= :run)"""