#!/usr/bin/env python
"""
_Statistics on DQM jobs_
 **developing version**
"""


from T0.DAS.Database.Oracle.Stats.StatsRepackMerge import StatsRepackMerge


class StatsDQM(StatsRepackMerge):
    
    
    sql=""" SELECT COUNT(*) as count,  status 
from (
SELECT DISTINCT j.id,   CASE  
        WHEN js.name='cleanout' and j.outcome=1  THEN 'complete'
        WHEN js.name='cleanout' and j.outcome=0 THEN 'failed' 
        WHEN js.name!='cleanout'   THEN 'acquired'
        else 'error'
END as status
 
FROM   wmbs_job j
INNER JOIN wmbs_job_assoc assoc          ON (j.id              = assoc.job)
INNER JOIN wmbs_job_state js ON j.state = js.id 
INNER JOIN wmbs_jobgroup jg              ON (jg.id = j.jobgroup ) 
INNER JOIN wmbs_subscription ws          ON (jg.subscription = ws.id) 
INNER JOIN  wmbs_file_details            ON  wmbs_file_details.id                         =  assoc.fileid
INNER JOIN  wmbs_file_dataset_path_assoc ON  wmbs_file_details.id                         =  wmbs_file_dataset_path_assoc.file_id
INNER JOIN  dataset_path                 ON  wmbs_file_dataset_path_assoc.dataset_path_id =  dataset_path.id  %s
 WHERE  dataset_path.data_tier =      (SELECT   data_tier.id FROM data_tier WHERE data_tier.name = 'DQM')
)
group by status
order by status"""
    
  

    sqlRun="""    INNER JOIN  wmbs_file_runlumi_map m  ON (assoc.fileid = m.fileid and  m.run = :run)  """
    
    def buildQuery(self):
        self.sql=self.sql % (self.sqlRun)
        