#!/usr/bin/env python
"""
_Statistics on Express jobs_
if run is not an integer or run<=0 then the statistics are the whole system's ones!!
if run>0 then the statistics are the single run's ones!!
T0Mon: This class is used in frontpage and in every run page for the statistical table
"""

from WMCore.Database.DBFormatter import DBFormatter
from T0.DAS.Database.Oracle.Stats.StatsConstants import fixRepackTables
#from T0.DAS.Database.Oracle.Stats.StatsConstants import printSQL

class StatsExpress(DBFormatter):
    #the last  right outer join is needed for the 0 value results
    sql= "SELECT \
         COUNT( DISTINCT jd.job_id ) as count, js.status \
         FROM express_job_def jd  %s \
         RIGHT OUTER JOIN job_status js  ON ( js.id =jd.job_status ) \
         GROUP BY js.status"
         
    sqlRunExtension="""  \
         INNER JOIN express_job_streamer_assoc assoc ON (jd.job_id = assoc.job_id)  \
         INNER JOIN ( \
               SELECT * from  streamer s \
               WHERE   s.run_id =:run  \
               )stream ON (stream.streamer_id = assoc.streamer_id)"""
         
         
         
    def execute(self, run, conn = None, transaction = False):
        """
        _execute_

        Execute the SQL for the given Express statistics and then format and return
        the result.
        """
        bindVars={}
        try:
          #print run
          if int(run)>0:
           self.sql=self.sql %(self.sqlRunExtension)
           bindVars = {"run": run}
          else: 
            raise Exception('zeroRun')
        except Exception:
           #print e
           self.sql=self.sql % ("")
        #print self.sql
        result = self.dbi.processData(self.sql, bindVars, conn = conn,
                                      transaction = transaction)
        #service={}
        #if printSQL:
          #service = {'sql': self.sql}
        #if len(service)>0:
         #return self.formatDict(result) +[service,]
        return self.formatDict(result)