#!/usr/bin/env python
"""
_Short information about the last streams_

T0Mon: this class is used in the plot generation
"""


from WMCore.Database.DBFormatter import DBFormatter
#
class LastStreamsSummary(DBFormatter): 

   sql="""SELECT s.name as stream, st.insert_time as time, st.filesize as filesize, st.events as events
    FROM
    streamer st
    INNER JOIN stream  s ON (s.id= st.stream_id)
    WHERE st.insert_time> :stime AND st.insert_time< :etime 
    ORDER BY st.insert_time DESC
    """

  
   def execute(self, stime,etime,conn = None, transaction = False):
        """
        _execute_

        Execute the SQL for the given  statistics and then format and return
        the result.
        """
        bindVars={}
        try:
          bindVars = {"stime": str(stime),"etime": str(etime)}
        except Exception as e:
            return {"Error" : "wrong time"}
        
        result = self.dbi.processData(self.sql, bindVars, conn = conn,
                                      transaction = transaction)
        
        return self.formatDict(result) 
 
 
