#!/usr/bin/env python
"""
_ Express  Merge job Lifetimes_

T0Mon query: this class is used to produce the Express Merge statistical plots 
"""

from T0.DAS.Database.Oracle.Timing.ExpressJobLifetime import ExpressJobLifetime

class ExpressMergeJobLifetime(ExpressJobLifetime):
    """
    sql and sqlRunExtension are overriden from the super class (all other methods are inherited)
    """
    sql= """
    SELECT  DISTINCT j.id as job_id,
     j.state_time as endTime,
     jg.last_update as startTime, 
     (j.state_time-jg.last_update) as diff
FROM     wmbs_job j
INNER JOIN wmbs_jobgroup jg               ON (jg.id             = j.jobgroup )
INNER JOIN wmbs_subscription ws           ON (jg.subscription   = ws.id) 
INNER JOIN wmbs_job_state js ON (j.state = js.id ) %s 
WHERE  ws.fileset = (SELECT id FROM wmbs_fileset WHERE name ='ExpressMergeable' )
AND js.name='cleanout' and j.outcome=1
  %s
 ORDER BY  j.state_time"""
         
    sqlRunExtension=""" 
     INNER JOIN wmbs_job_assoc assoc           ON (j.id              = assoc.job) 
     INNER JOIN  wmbs_file_runlumi_map m  ON (assoc.fileid = m.fileid and  m.run = :run) """
    sqlTimeLimits="""
    AND j.state_time > :stime
    AND jg.last_update < :etime """
         
    sqlNotNullCheck=" AND j.id>0 "
          
