#!/usr/bin/env python
"""
_ Reco job Lifetimes_

T0Mon query: this class is used to produce the Reco statistical plots 
"""

from T0.DAS.Database.Oracle.Timing.ExpressJobLifetime import ExpressJobLifetime

class RecoJobLifetime(ExpressJobLifetime):
    """
    sql and sqlRunExtension are overridden, moreover buildQuery is updated  
    """
    sql= """
   SELECT DISTINCT j.id as job_id,
j.state_time as endTime,
jg.last_update as startTime,
(j.state_time-jg.last_update) as diff
FROM   wmbs_job j
INNER JOIN wmbs_job_state js ON j.state = js.id 
INNER JOIN  wmbs_jobgroup jg ON (jg.id = j.jobgroup ) %s
 WHERE jg.subscription =   ( SELECT id FROM  wmbs_fileset WHERE name =  %s)
 %s  
 ORDER BY j.state_time"""
         
    sqlRunExtension=""" 
     INNER JOIN wmbs_job_assoc assoc           ON (j.id              = assoc.job) 
     INNER JOIN  wmbs_file_runlumi_map m  ON (assoc.fileid = m.fileid and  m.run = :run) """
    sqlNotNullCheck=" AND j.id>0 "
    
    fileset="'Reconstructable'"
    sqlTimeLimits="""
    AND jg.last_update> :stime
    AND j.state_time< :etime """      
    def buildQuery(self):
     self.sql=self.sql%(self.sqlRunExtension,self.fileset,self.sqlTimeLimits)