#!/usr/bin/env python
"""
_ Repack  Merge job Lifetimes_

T0Mon query: this class is used to produce the Repack Merge statistical plots 
"""

from T0.DAS.Database.Oracle.Timing.ExpressJobLifetime import ExpressJobLifetime

class RepackMergeJobLifetime(ExpressJobLifetime):
    """
    sql and sqlRunExtension are overridden, moreover buildQuery is updated (to use dataTier/subscription)  
    """
    sql= """
    SELECT DISTINCT j.id as job_id,
     j.state_time as endTime,
     jg.last_update as startTime,
     (j.state_time-jg.last_update) as diff
FROM   wmbs_job j
INNER JOIN wmbs_job_assoc assoc          ON (j.id              = assoc.job)
INNER JOIN wmbs_job_state js ON j.state = js.id 
INNER JOIN wmbs_jobgroup jg              ON (jg.id = j.jobgroup ) 
INNER JOIN wmbs_subscription ws          ON (jg.subscription = ws.id) 
INNER JOIN  wmbs_file_details            ON  wmbs_file_details.id                         =  assoc.fileid
INNER JOIN  wmbs_file_dataset_path_assoc ON  wmbs_file_details.id                         =  wmbs_file_dataset_path_assoc.file_id
INNER JOIN  dataset_path                 ON  wmbs_file_dataset_path_assoc.dataset_path_id =  dataset_path.id  %s
 WHERE  dataset_path.data_tier =      (SELECT   data_tier.id FROM data_tier WHERE data_tier.name = %s  )
 AND ws.fileset =  (SELECT id FROM wmbs_fileset WHERE name = %s )
 AND js.name='cleanout' and j.outcome=1
 %s
 ORDER BY jg.last_update"""
         
    sqlRunExtension=""" 
     INNER JOIN  wmbs_file_runlumi_map m  ON (assoc.fileid = m.fileid and  m.run = :run) """
    dataTier="'RAW'"
    subscription="'Mergeable'"
    sqlTimeLimits=""" 
     AND j.state_time> :stime
     AND jg.last_update <:etime """
    sqlNotNullCheck=" AND j.id>0 "
          
    def buildQuery(self):
     self.sql=self.sql%(self.sqlRunExtension,self.dataTier,self.subscription,self.sqlTimeLimits)
     
