#!/usr/bin/env python
"""
_RuntimeAlcaHarvest_

"""

__revision__ = "$Id: RuntimeAlcaHarvest.py,v 1.1 2010/08/03 15:34:12 hufnagel Exp $"
__version__ = "$Revision: 1.1 $"

import os
import subprocess

from ProdCommon.MCPayloads.JobSpec import JobSpec
from ProdCommon.MCPayloads.WorkflowSpec import WorkflowSpec


def copyFiles(workflowSpec, jobSpec):
    """
    hack for now, just copy promptCalibConditions.db

    """
    loadedWorkflowSpec = WorkflowSpec()
    loadedWorkflowSpec.load(workflowSpec)

    target = loadedWorkflowSpec.parameters.get("SqliteTargetDir")

    sqlitefile = 'promptCalibConditions.db'
    
    #ALCAPROMPTHarvest-Run141410-ZeroBias-ALCAPROMPT-32-JobSpec.xml
    #ALCAPROMPTHarvest-Run141410-ZeroBias-ALCAPROMPT-32.db
    fileName = jobSpec.split('/')[-1]
    fileName = fileName[:-len('-JobSpec.xml')] + ".db"

    outpath = os.path.join(target, fileName)
    print '==> stage out %s to %s' % (sqlitefile, outpath)

    subprocess.call(["rfcp", sqlitefile, outpath])


def main():
    """
    _main_

    Verify that the environment variable that points at the job spec
    has been set correctly and call the post processing functions.
    
    """
    print "==================AlcaHarvest Post Processing======================"

    workflowSpec = os.environ.get("PRODAGENT_WORKFLOW_SPEC", None)
    if workflowSpec == None:
        msg = "Unable to find WorkflowSpec from "
        msg += "PRODAGENT_WORKFLOW_SPEC variable\n"
        msg += "Unable to proceed\n"
        raise RuntimeError, msg

    if not os.path.exists(workflowSpec):
        msg = "Cannot find WorkflowSpec file:\n %s\n" % workflowSpec
        msg += "Unable to proceed\n"
        raise RuntimeError, msg

    jobSpec = os.environ.get("PRODAGENT_JOBSPEC", None)
    if jobSpec == None:
        msg = "Unable to find JobSpec from "
        msg += "PRODAGENT_JOBSPEC variable\n"
        msg += "Unable to proceed\n"
        raise RuntimeError, msg

    if not os.path.exists(jobSpec):
        msg = "Cannot find JobSpec file:\n %s\n" % jobSpec
        msg += "Unable to proceed\n"
        raise RuntimeError, msg

    copyFiles(workflowSpec, jobSpec)

    print "==================AlcaHarvest Post Processing Done================="

if __name__ == '__main__':
    main()
