"""
_MergePack_

Job handler for MergePack jobs.
"""

__revision__ = "$"
__version__ = "$"

import logging
from sets import Set

from WMCore.WMBS.File import File as WMBSFile
from WMCore.WMBS.Fileset import Fileset as WMBSFileset

from T0.Tier0Accountant.WMBSBaseHandler import WMBSBaseHandler

class ExpressDQMHarvest(WMBSBaseHandler):
    """
    _ExpressDQMHarvest_

    Job handler for ExpressDQMHarvest jobs.
    only needs to update job status
    TO: maybe need to delete input files as well. but hard to know when periodic 
        dqm harvest job is done.
    """
    def handleSuccessfulJob(self, jobInfo, jobFiles):
        """
        _handleSuccessfulJob_
        
        Currently ExpressDQMHarvest job needs only state update.
        So it is not needed to overwrite handleSuccessfulJob - Just sanity check is added
        """
        if len(jobFiles) != 0:
            msg = "There should be no output files - investigate: %s" % jobFiles
            logging.debug(msg)
            raise Exception, msg
        
        WMBSBaseHandler.handleSuccessfulJob(self, jobInfo, jobFiles)
        